<!DOCTYPE html>
<html lang="en">
<head>
    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=0"/>
    <meta charset="utf-8"/>
    <title>API Documentation &raquo;\PhpOffice\PhpSpreadsheet\Shared\JAMA\EigenvalueDecomposition</title>
    <meta name="author" content=""/>
    <meta name="description" content=""/>        <link href="../css/template.css" rel="stylesheet" media="all"/>        <!--[if lt IE 9]>
        <script src="https://html5shim.googlecode.com/svn/trunk/html5.js" type="text/javascript"></script>
        <![endif]-->
        <script src="../js/jquery-1.7.1.min.js" type="text/javascript"></script>
        <script src="../js/jquery-ui-1.8.2.custom.min.js" type="text/javascript"></script>
        <script src="../js/jquery.mousewheel.min.js" type="text/javascript"></script>
        <script src="../js/bootstrap.js" type="text/javascript"></script>
        <script src="../js/template.js" type="text/javascript"></script>
        <script src="../js/prettify/prettify.min.js" type="text/javascript"></script>        <link rel="shortcut icon" href="../img/favicon.ico"/>
        <link rel="apple-touch-icon" href="../img/apple-touch-icon.png"/>
        <link rel="apple-touch-icon" sizes="72x72" href="../img/apple-touch-icon-72x72.png"/>
        <link rel="apple-touch-icon" sizes="114x114" href="../img/apple-touch-icon-114x114.png"/></head>
<body>    <div class="navbar navbar-fixed-top">
        <div class="navbar-inner">
            <div class="container">
                <a class="btn btn-navbar" data-toggle="collapse" data-target=".nav-collapse">
                    <span class="icon-bar"></span> <span class="icon-bar"></span>
                    <span class="icon-bar"></span> </a>
                <a class="brand" href="../index.html">API Documentation</a>

                <div class="nav-collapse">
                    <ul class="nav">
                        <li class="dropdown">
                            <a href="#api" class="dropdown-toggle" data-toggle="dropdown">
                                API Documentation <b class="caret"></b>
                            </a>
                            <ul class="dropdown-menu">                                    <li><a>Namespaces</a></li>                                    <li><a href="../namespaces/task_23.html">task_23</a></li>                                    <li><a href="../namespaces/task_18.html">task_18</a></li>                                    <li><a href="../namespaces/task_22.html">task_22</a></li>                                    <li><a href="../namespaces/Composer.html">Composer</a></li>                                    <li><a href="../namespaces/Matrix.html">Matrix</a></li>                                    <li><a href="../namespaces/Complex.html">Complex</a></li>                                    <li><a href="../namespaces/Psr.html">Psr</a></li>                                    <li><a href="../namespaces/PhpOffice.html">PhpOffice</a></li>                                    <li><a href="../namespaces/Samples.html">Samples</a></li>                                    <li><a href="../namespaces/task_21.html">task_21</a></li>                                    <li><a href="../namespaces/task_24.html">task_24</a></li>                                    <li><a href="../namespaces/task_20.html">task_20</a></li>                                    <li><a href="../namespaces/task_17.html">task_17</a></li>                                    <li><a href="../namespaces/task_19.html">task_19</a></li>                            </ul>
                        </li>
                        <li class="dropdown" id="charts-menu">
                            <a href="#charts" class="dropdown-toggle" data-toggle="dropdown">
                                Charts <b class="caret"></b>
                            </a>
                            <ul class="dropdown-menu">
                                <li>
                                    <a href="../graph_class.html">
                                        <i class="icon-list-alt"></i>&#160;Class hierarchy diagram
                                    </a>
                                </li>
                            </ul>
                        </li>
                        <li class="dropdown" id="reports-menu">
                            <a href="#reports" class="dropdown-toggle" data-toggle="dropdown">
                                Reports <b class="caret"></b>
                            </a>
                            <ul class="dropdown-menu">
                                <li>
                                    <a href="../errors.html">
                                        <i class="icon-list-alt"></i>&#160;Errors
                                    </a>
                                </li>
                                <li>
                                    <a href="../markers.html">
                                        <i class="icon-list-alt"></i>&#160;Markers
                                    </a>
                                </li>
                                <li>
                                    <a href="../deprecated.html">
                                        <i class="icon-list-alt"></i>&#160;Deprecated
                                    </a>
                                </li>
                            </ul>
                        </li>
                    </ul>
                </div>
            </div>
        </div>
        <div class="go_to_top">
            <a href="#___" style="color: inherit">Back to top&#160;&#160;<i class="icon-upload icon-white"></i></a>
        </div>
    </div>
    <div id="___" class="container">
        <noscript>
            <div class="alert alert-warning">
                Javascript is disabled; several features are only available if Javascript is enabled.
            </div>
        </noscript>    <style>
        .deprecated h2 {
            text-decoration: line-through;
        }
    </style>
    <div class="row">
        <div class="span4">    <div class="btn-group view pull-right" data-toggle="buttons-radio">
        <button class="btn details" title="Show descriptions and method names"><i class="icon-list"></i></button>
        <button class="btn simple" title="Show only method names"><i class="icon-align-justify"></i></button>
    </div>
    <div class="btn-group visibility" data-toggle="buttons-checkbox">
        <button class="btn public active" title="Show public elements">Public</button>
        <button class="btn protected" title="Show protected elements">Protected</button>
        <button class="btn private" title="Show private elements">Private</button>
        <button class="btn inherited active" title="Show inherited elements">Inherited</button>
    </div>    <ul class="side-nav nav nav-list">
        <li class="nav-header">
            <i class="icon-custom icon-method"></i> Methods
            <ul>    <li class="methodpublic">
        <a href="#method___construct" title="__construct ::Constructor: Check for symmetry, then construct the eigenvalue decomposition.">
            <span class="description">Constructor: Check for symmetry, then construct the eigenvalue decomposition.</span><pre>__construct</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_getD" title="getD ::Return the block diagonal eigenvalue matrix.">
            <span class="description">Return the block diagonal eigenvalue matrix.</span><pre>getD</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_getImagEigenvalues" title="getImagEigenvalues ::Return the imaginary parts of the eigenvalues.">
            <span class="description">Return the imaginary parts of the eigenvalues.</span><pre>getImagEigenvalues</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_getRealEigenvalues" title="getRealEigenvalues ::Return the real parts of the eigenvalues.">
            <span class="description">Return the real parts of the eigenvalues.</span><pre>getRealEigenvalues</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_getV" title="getV ::Return the eigenvector matrix.">
            <span class="description">Return the eigenvector matrix.</span><pre>getV</pre>
        </a>
    </li>            </ul>
        </li>
        <li class="nav-header protected">» Protected
            <ul>            </ul>
        </li>
        <li class="nav-header private">» Private
            <ul>                        <li class="methodprivate">
                            <a href="#method_cdiv" title="cdiv ::Performs complex division.">
                                <span class="description">Performs complex division.</span><pre>cdiv</pre>
                            </a>
                        </li>                        <li class="methodprivate">
                            <a href="#method_hqr2" title="hqr2 ::Nonsymmetric reduction from Hessenberg to real Schur form.">
                                <span class="description">Nonsymmetric reduction from Hessenberg to real Schur form.</span><pre>hqr2</pre>
                            </a>
                        </li>                        <li class="methodprivate">
                            <a href="#method_orthes" title="orthes ::Nonsymmetric reduction to Hessenberg form.">
                                <span class="description">Nonsymmetric reduction to Hessenberg form.</span><pre>orthes</pre>
                            </a>
                        </li>                        <li class="methodprivate">
                            <a href="#method_tql2" title="tql2 ::Symmetric tridiagonal QL algorithm.">
                                <span class="description">Symmetric tridiagonal QL algorithm.</span><pre>tql2</pre>
                            </a>
                        </li>                        <li class="methodprivate">
                            <a href="#method_tred2" title="tred2 ::Symmetric Householder reduction to tridiagonal form.">
                                <span class="description">Symmetric Householder reduction to tridiagonal form.</span><pre>tred2</pre>
                            </a>
                        </li>            </ul>
        </li>
        <li class="nav-header">
            <i class="icon-custom icon-constant"></i> Constants
            <ul>            </ul>
        </li>
    </ul>
        </div>

        <div class="span8">
            <div class="element class">
                <h1>EigenvalueDecomposition</h1>
                <small style="display: block; text-align: right">                </small>
                <p class="short_description">Class to obtain eigenvalues and eigenvectors of a real matrix.</p>
                <div class="details">
                    <div class="long_description"><p>If A is symmetric, then A = V<em>D</em>V' where the eigenvalue matrix D
is diagonal and the eigenvector matrix V is orthogonal (i.e.
A = V.times(D.times(V.transpose())) and V.times(V.transpose())
equals the identity matrix).</p>
<p>If A is not symmetric, then the eigenvalue matrix D is block diagonal
with the real eigenvalues in 1-by-1 blocks and any complex eigenvalues,
lambda + i<em>mu, in 2-by-2 blocks, [lambda, mu; -mu, lambda].  The
columns of V represent the eigenvectors in the sense that A</em>V = V<em>D,
i.e. A.times(V) equals V.times(D).  The matrix V may be badly
conditioned, or even singular, so the validity of the equation
A = V</em>D*inverse(V) depends upon V.cond().</p>
                    </div>
                    <table class="table table-bordered">                                <tr>
                                    <th>author                                    </th>
                                    <td><p>Paul Meagher</p>
<p>@version 1.1</p>
                                    </td>
                                </tr>                                <tr>
                                    <th>package                                    </th>
                                    <td><p>Default</p>
                                    </td>
                                </tr>                    </table>

                    <h3><i class="icon-custom icon-method"></i> Methods</h3>                        <a id="method___construct"></a>
                        <div class="element clickable methodpublic method___construct" data-toggle="collapse" data-target=".method___construct .collapse">
                            <h2>Constructor: Check for symmetry, then construct the eigenvalue decomposition.</h2>
                            <pre>__construct(mixed $Arg)</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                    </table>                                        <h3>Arguments</h3>                                            <div class="subelement argument">
                                                <h4>$Arg</h4>
                                                <code>mixed</code><p><p>A Square matrix</p></p>
                                            </div>                                </div>
                            </div>

                        </div>                        <a id="method_cdiv"></a>
                        <div class="element clickable methodprivate method_cdiv" data-toggle="collapse" data-target=".method_cdiv .collapse">
                            <h2>Performs complex division.</h2>
                            <pre>cdiv(mixed $xr,mixed $xi,mixed $yr,mixed $yi)</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                    </table>                                        <h3>Arguments</h3>                                            <div class="subelement argument">
                                                <h4>$xr</h4>
                                                <code>mixed</code><p></p>
                                            </div>                                            <div class="subelement argument">
                                                <h4>$xi</h4>
                                                <code>mixed</code><p></p>
                                            </div>                                            <div class="subelement argument">
                                                <h4>$yr</h4>
                                                <code>mixed</code><p></p>
                                            </div>                                            <div class="subelement argument">
                                                <h4>$yi</h4>
                                                <code>mixed</code><p></p>
                                            </div>                                </div>
                            </div>

                        </div>                        <a id="method_getD"></a>
                        <div class="element clickable methodpublic method_getD" data-toggle="collapse" data-target=".method_getD .collapse">
                            <h2>Return the block diagonal eigenvalue matrix.</h2>
                            <pre>getD(): \PhpOffice\PhpSpreadsheet\Shared\JAMA\Matrix</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                    </table>                                        <h3>Response</h3>
                                        <code>\PhpOffice\PhpSpreadsheet\Shared\JAMA\Matrix</code><p><p>D</p></p>                                </div>
                            </div>

                        </div>                        <a id="method_getImagEigenvalues"></a>
                        <div class="element clickable methodpublic method_getImagEigenvalues" data-toggle="collapse" data-target=".method_getImagEigenvalues .collapse">
                            <h2>Return the imaginary parts of the eigenvalues.</h2>
                            <pre>getImagEigenvalues(): array</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                    </table>                                        <h3>Response</h3>
                                        <code>array</code><p><p>imag(diag(D))</p></p>                                </div>
                            </div>

                        </div>                        <a id="method_getRealEigenvalues"></a>
                        <div class="element clickable methodpublic method_getRealEigenvalues" data-toggle="collapse" data-target=".method_getRealEigenvalues .collapse">
                            <h2>Return the real parts of the eigenvalues.</h2>
                            <pre>getRealEigenvalues(): array</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                    </table>                                        <h3>Response</h3>
                                        <code>array</code><p><p>real(diag(D))</p></p>                                </div>
                            </div>

                        </div>                        <a id="method_getV"></a>
                        <div class="element clickable methodpublic method_getV" data-toggle="collapse" data-target=".method_getV .collapse">
                            <h2>Return the eigenvector matrix.</h2>
                            <pre>getV(): \PhpOffice\PhpSpreadsheet\Shared\JAMA\Matrix</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                    </table>                                        <h3>Response</h3>
                                        <code>\PhpOffice\PhpSpreadsheet\Shared\JAMA\Matrix</code><p><p>V</p></p>                                </div>
                            </div>

                        </div>                        <a id="method_hqr2"></a>
                        <div class="element clickable methodprivate method_hqr2" data-toggle="collapse" data-target=".method_hqr2 .collapse">
                            <h2>Nonsymmetric reduction from Hessenberg to real Schur form.</h2>
                            <pre>hqr2()</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"><p>Code is derived from the Algol procedure hqr2,
by Martin and Wilkinson, Handbook for Auto. Comp.,
Vol.ii-Linear Algebra, and the corresponding
Fortran subroutine in EISPACK.</p></div>

                                    <table class="table">                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                    </table>                                </div>
                            </div>

                        </div>                        <a id="method_orthes"></a>
                        <div class="element clickable methodprivate method_orthes" data-toggle="collapse" data-target=".method_orthes .collapse">
                            <h2>Nonsymmetric reduction to Hessenberg form.</h2>
                            <pre>orthes()</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"><p>This is derived from the Algol procedures orthes and ortran,
by Martin and Wilkinson, Handbook for Auto. Comp.,
Vol.ii-Linear Algebra, and the corresponding
Fortran subroutines in EISPACK.</p></div>

                                    <table class="table">                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                    </table>                                </div>
                            </div>

                        </div>                        <a id="method_tql2"></a>
                        <div class="element clickable methodprivate method_tql2" data-toggle="collapse" data-target=".method_tql2 .collapse">
                            <h2>Symmetric tridiagonal QL algorithm.</h2>
                            <pre>tql2()</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"><p>This is derived from the Algol procedures tql2, by
Bowdler, Martin, Reinsch, and Wilkinson, Handbook for
Auto. Comp., Vol.ii-Linear Algebra, and the corresponding
Fortran subroutine in EISPACK.</p></div>

                                    <table class="table">                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                    </table>                                </div>
                            </div>

                        </div>                        <a id="method_tred2"></a>
                        <div class="element clickable methodprivate method_tred2" data-toggle="collapse" data-target=".method_tred2 .collapse">
                            <h2>Symmetric Householder reduction to tridiagonal form.</h2>
                            <pre>tred2()</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                    </table>                                </div>
                            </div>

                        </div>                        <h3><i class="icon-custom icon-property"></i> Properties</h3>                            <a id="property_n"> </a>
                            <div class="element clickable propertyprivate property_n" data-toggle="collapse" data-target=".property_n .collapse">
                                <h2>Row and column dimension (square matrix).</h2>
                                <pre>n :integer</pre>
                                <div class="labels">                                </div>
                                <div class="row collapse">
                                    <div class="detail-description">
                                        <div class="long_description"></div>

                                        <table class="table">                                                <tr>
                                                    <th>var
                                                    </th>
                                                    <td>                                                    </td>
                                                </tr>                                        </table>                                            <h3>Type(s)</h3>
                                            <code>integer</code>                                    </div>
                                </div>
                            </div>                            <a id="property_d"> </a>
                            <div class="element clickable propertyprivate property_d" data-toggle="collapse" data-target=".property_d .collapse">
                                <h2>Arrays for internal storage of eigenvalues.</h2>
                                <pre>d :array</pre>
                                <div class="labels">                                </div>
                                <div class="row collapse">
                                    <div class="detail-description">
                                        <div class="long_description"></div>

                                        <table class="table">                                                <tr>
                                                    <th>var
                                                    </th>
                                                    <td>                                                    </td>
                                                </tr>                                        </table>                                            <h3>Type(s)</h3>
                                            <code>array</code>                                    </div>
                                </div>
                            </div>                            <a id="property_e"> </a>
                            <div class="element clickable propertyprivate property_e" data-toggle="collapse" data-target=".property_e .collapse">
                                <h2>e</h2>
                                <pre>e :</pre>
                                <div class="labels">                                </div>
                                <div class="row collapse">
                                    <div class="detail-description">
                                        <div class="long_description"></div>

                                        <table class="table">                                                <tr>
                                                    <th>
                                                    </th>
                                                    <td>                                                    </td>
                                                </tr>                                        </table>                                            <h3>Type(s)</h3>
                                            <code></code>                                    </div>
                                </div>
                            </div>                            <a id="property_V"> </a>
                            <div class="element clickable propertyprivate property_V" data-toggle="collapse" data-target=".property_V .collapse">
                                <h2>Array for internal storage of eigenvectors.</h2>
                                <pre>V :array</pre>
                                <div class="labels">                                </div>
                                <div class="row collapse">
                                    <div class="detail-description">
                                        <div class="long_description"></div>

                                        <table class="table">                                                <tr>
                                                    <th>var
                                                    </th>
                                                    <td>                                                    </td>
                                                </tr>                                        </table>                                            <h3>Type(s)</h3>
                                            <code>array</code>                                    </div>
                                </div>
                            </div>                            <a id="property_H"> </a>
                            <div class="element clickable propertyprivate property_H" data-toggle="collapse" data-target=".property_H .collapse">
                                <h2>Array for internal storage of nonsymmetric Hessenberg form.</h2>
                                <pre>H :array</pre>
                                <div class="labels">                                </div>
                                <div class="row collapse">
                                    <div class="detail-description">
                                        <div class="long_description"></div>

                                        <table class="table">                                                <tr>
                                                    <th>var
                                                    </th>
                                                    <td>                                                    </td>
                                                </tr>                                        </table>                                            <h3>Type(s)</h3>
                                            <code>array</code>                                    </div>
                                </div>
                            </div>                            <a id="property_ort"> </a>
                            <div class="element clickable propertyprivate property_ort" data-toggle="collapse" data-target=".property_ort .collapse">
                                <h2>Working storage for nonsymmetric algorithm.</h2>
                                <pre>ort :array</pre>
                                <div class="labels">                                </div>
                                <div class="row collapse">
                                    <div class="detail-description">
                                        <div class="long_description"></div>

                                        <table class="table">                                                <tr>
                                                    <th>var
                                                    </th>
                                                    <td>                                                    </td>
                                                </tr>                                        </table>                                            <h3>Type(s)</h3>
                                            <code>array</code>                                    </div>
                                </div>
                            </div>                            <a id="property_cdivr"> </a>
                            <div class="element clickable propertyprivate property_cdivr" data-toggle="collapse" data-target=".property_cdivr .collapse">
                                <h2>Used for complex scalar division.</h2>
                                <pre>cdivr :float</pre>
                                <div class="labels">                                </div>
                                <div class="row collapse">
                                    <div class="detail-description">
                                        <div class="long_description"></div>

                                        <table class="table">                                                <tr>
                                                    <th>var
                                                    </th>
                                                    <td>                                                    </td>
                                                </tr>                                        </table>                                            <h3>Type(s)</h3>
                                            <code>float</code>                                    </div>
                                </div>
                            </div>                            <a id="property_cdivi"> </a>
                            <div class="element clickable propertyprivate property_cdivi" data-toggle="collapse" data-target=".property_cdivi .collapse">
                                <h2>cdivi</h2>
                                <pre>cdivi :</pre>
                                <div class="labels">                                </div>
                                <div class="row collapse">
                                    <div class="detail-description">
                                        <div class="long_description"></div>

                                        <table class="table">                                                <tr>
                                                    <th>
                                                    </th>
                                                    <td>                                                    </td>
                                                </tr>                                        </table>                                            <h3>Type(s)</h3>
                                            <code></code>                                    </div>
                                </div>
                            </div>                </div>
            </div>
            <a id="\PhpOffice\PhpSpreadsheet\Shared\JAMA\EigenvalueDecomposition"></a>
            <ul class="breadcrumb">
                <li><a href="../index.html"><i class="icon-custom icon-class"></i></a></li>
    <li><span class="divider">\</span><a href="../namespaces/PhpOffice.PhpSpreadsheet.Shared.JAMA.html">JAMA</a></li>
                <li class="active"><span class="divider">\</span><a href="../classes/PhpOffice.PhpSpreadsheet.Shared.JAMA.EigenvalueDecomposition.html">EigenvalueDecomposition</a></li>
            </ul>
        </div>
    </div>    </div>    <footer class="span12">
            Template is built using <a href="http://twitter.github.com/bootstrap/">Twitter Bootstrap 2</a> and icons provided by
            <a href="http://glyphicons.com/">Glyphicons</a>.<br/>
            Documentation is powered by <a href="http://www.phpdoc.org/">phpDocumentor</a> and<br/>
            generated onFri, 14 Feb 2020 19:36:49 +0000.<br/>
    </footer></body>
</html>
